/*
    Scrivere una function C per implementare l'algoritmo Quick Sort.
*/
#include<stdlib.h>
#include<stdio.h>
#include<time.h>
#define DIM 10


void swap(int *a, int*b)
{
    int temp;
    
    temp=*a;
    *a=*b;
    *b=temp;
}

int Partiziona(int *a, int inizio, int fine)
{
    int i, j, x,temp;
    
    //dovr scorrere gli array da inizio verso destra, da fine verso sinistra;
    i=inizio;//da sinistra verso destra <=> i
    
    x=a[inizio];/*Prendo il partizionatore <=> migliora l'algoritmo se scelto
                  in maniera Random*/

    j = fine - 1;//inidce usato per scorrere da destra verso sinistra <=> j
    
    //fin quando i due indici non si incontrano procedendo in versi opposti
    while (i<= j)
    {
        /*Decrementa j fin quando a[j] > del partizionatore e 
        non si  incontrata con j*/
        while(  (a[j] > x) && (i<= j))   j--; 
        /*Incrementa i fin quando i due indici non si sono incontrati
          e a[i]<= del pivot        */
        while(  a[i] <= x && (i<= j))i++;   
            
            //Se i non ha ancora incontrato j
            if(i < j)       
            {   
                swap(&a[i], &a[j]);//Qui avviene lo scambio "attorno" al perno
                i++;                    
                j--;
            }

    }

    //Con questa istruzione il pivot andr nella sua posizione finale
    swap(&a[j], &a[(fine)-1]);
    return fine;//Ritorno l'indice di fine.

}

/*Procedura Divide et Impera QuickSort che vuole in ingresso l'array, indice 
  che segnala da dove partire con l'ordinamento, l'indice che segnala dove
  finire di ordinare l'array.
*/
void QuickSort(int *a, int inizio, int fine)
{
    int indice_partizionatore;
    
    if(inizio<fine)
    {
        indice_partizionatore=Partiziona(a, inizio, fine);
        
        QuickSort(a, inizio, indice_partizionatore-1);
        QuickSort(a, indice_partizionatore+1, fine);
    }
}

//Stampa del vettore
void stampa(int*v)
{
    int i;
    for(i=0; i<DIM; i++)
    printf("a[%d]= %d\n", i, v[i]);
}

//Genera il riempimento del vettore con elementi ai / ai  [0;100], V ai  N
void riempi(int *v)
{
    int i;
    for(i=0; i<DIM; i++)
    {
        v[i]=(rand()%101);//Numeri da 0 a 100
    }
}


int main()
{
    int i;
    int vettore[DIM]={11,12,7,6,55,4,3,20,1,15};
    
    srand((unsigned)time(NULL));
    QuickSort(vettore, 0, DIM);
    stampa(vettore);    printf("\n");

    
    riempi(vettore);    
    QuickSort(vettore, 0, DIM);
    stampa(vettore);    printf("\n");
    
    riempi(vettore);    
    //Voglio ordinare solo una sottoporzione dell'array
    QuickSort(vettore, 2, DIM-2);
    printf("Ordino solo una parte dell'array Ordina[2; DIM-2]\n");
    stampa(vettore);
    
    
    system("pause");
    return 0;
};

